#! /usr/bin/python
# (c) 1999 by Mirko Zeibig <mz@webideal.de>
# Changelog:
# 12/10/1999 updated, now handles isdn.conf and options as well
# 09/13/1999 first version 0.51
#
# Userfriendly text-ui configurator

import glob, shutil, time, re
from snack import *
from rh_isdnconf import *
import rh_isdn_dlg
rh_isdn_dlg.CS_TITLE=sTitle
from rh_isdn_dlg import *

def ChangeOptions(sName):
  oFile=open(OPTIONS, 'r')
  aLines=oFile.read()
  oFile.close()
  pat=re.compile('^user\ \"(.*)\"$', re.M)
  aLines=pat.sub('user "' + sName +'"', aLines, re.M)
  oFile=open(OPTIONS, 'w')
  oFile.write(aLines)
  oFile.close()
	
def RCBackup(sFile):
	lstFile=glob.glob(sFile)
	if len(lstFile)!=0:
		shutil.copy(sFile, sFile + '.' + str(time.time()))
		

# Save the definitions
def RCSave(sFile,dctTemp):
	#RCBackup(sFile)
	filOut=open(sFile,'w')
	for sTemp in dctTemp['SAV_STRINGS']:
		filOut.write('# ' + dctTemp['KEYS'][sTemp]['COMMENT'] + '\n')
		filOut.write(sTemp + '="' + dctTemp['KEYS'][sTemp]['VALUE'] + '"\n')
	filOut.close()

def AuthSave(dctTemp):
	#RCBackup(PAP_PATH)
	dctKeys=dctTemp['KEYS']
	filOut=open(PAP_PATH,'w')
	filOut.write('"' + dctKeys['PAP_USER']['VALUE'] + '"\t*\t"' + dctKeys['PAP_PASS']['VALUE'] + '"\n')
	filOut.close()
        ChangeOptions(dctKeys['PAP_USER']['VALUE'])

def IsdnConfSave(dctTemp):
  aLines=open(ISDNCONF, 'r').read()
  dctKeys=dctTemp['KEYS']
  for sTemp in dctTemp['SAV_STRINGS']:
    pat=re.compile('^'+ sTemp + '.*\=.*$', re.M)
    aLines=pat.sub(sTemp + ' = ' + dctKeys[sTemp]['VALUE'], aLines)
  open(ISDNCONF, 'w').write(aLines)

# main-part
screen=SnackScreen()
rc=ButtonChoiceWindow( \
	screen, \
	sTitle, \
	'Welcome to the rh-isdn-configurator!\n\n' + \
	'- you must have chosen your driver during kernel-\n' + \
	'  compilation\n' + \
	'- if you have a PnP-card, it should be set up already and\n' + \
	'  you should remember the values for IRQ, IO and MEM as well\n' + \
	'  as the value for your card-id (have a look in \n' + \
	'  /usr/src/linux/Documentation/isdn/)\n' + \
	'- if you choose "cancel", only the settings of the active dialog\n' + \
	'  will not be written\n', \
	width=70 \
)

# User-Cancel?
if rc=='cancel':
	screen.finish()
	exit

# IFCFG?
rc=CommentForm(screen, dctDLG['ISDN'])
frm=DictForm(screen,dctDLG['ISDN'])
fOK, dctResults=frm.run()
if fOK:
	RCSave(ISDN_RC,dctResults)

# IFCFG?
rc=CommentForm(screen, dctDLG['IFCFG'])
frm=DictForm(screen,dctDLG['IFCFG'])
fOK, dctResults=frm.run()
if fOK:
	if dctResults['KEYS']['SLAVE']['VALUE']=='yes':
		dctResults['KEYS']['SLAVE']['VALUE']='ippp1'
	RCSave(NET_SCRIPT,dctResults)

# ISDNCONF
rc=CommentForm(screen, dctDLG['ISDNCONF'])
frm=DictForm(screen, dctDLG['ISDNCONF'])
fOK, dctResults=frm.run()
if fOK:
  IsdnConfSave(dctResults)

# AUTHCFG?
rc=CommentForm(screen, dctDLG['AUTHCFG'])
frm=DictForm(screen,dctDLG['AUTHCFG'])
fOK, dctResults=frm.run()
if fOK:
	AuthSave(dctResults)

rc=ButtonChoiceWindow( \
	screen, \
	sTitle, \
	'Please make sure to alter /etc/isdn/callerid.conf\n' + \
	'to match your phone-numbers, this is not done yet!\n', \
	buttons = [ 'OK' ] \
)

screen.finish()

